<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblTemaXUsuarioRepository;

final class TblTemaXUsuarioService
{
    private TblTemaXUsuarioRepository $TblTemaXUsuarioRepository;

    public function __construct(TblTemaXUsuarioRepository $TblTemaXUsuarioRepository)
    {
        $this->TblTemaXUsuarioRepository = $TblTemaXUsuarioRepository;
    }

    public function checkAndGet(int $TblTemaXUsuarioId): object
    {
        return $this->TblTemaXUsuarioRepository->checkAndGet($TblTemaXUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblTemaXUsuarioRepository->getAll();
    }

    public function getOne(int $TblTemaXUsuarioId): object
    {
        return $this->checkAndGet($TblTemaXUsuarioId);
    }

    public function create(array $input): object
    {
        $TblTemaXUsuario = json_decode((string) json_encode($input), false);

        return $this->TblTemaXUsuarioRepository->create($TblTemaXUsuario);
    }

    public function update(array $input, int $TblTemaXUsuarioId): object
    {
        $TblTemaXUsuario = $this->checkAndGet($TblTemaXUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblTemaXUsuarioRepository->update($TblTemaXUsuario, $data);
    }

    public function delete(int $TblTemaXUsuarioId): void
    {
        $this->checkAndGet($TblTemaXUsuarioId);
        $this->TblTemaXUsuarioRepository->delete($TblTemaXUsuarioId);
    }
}
